__all__ = 'CachedValue'

import copy


class CachedValue:
    def __init__(self, value, is_cached = False):
        self._initial_value = copy.copy(value)
        self._value = value
        self._is_cached = is_cached

    def get_value(self):
        return self._value

    def set_value(self, value):
        self._value = value
        self._is_cached = True

    def is_cached(self):
        return self._is_cached

    def reset_and_clear_cache(self):
        self._value = copy.copy(self._initial_value)
        self._is_cached = False
