__all__ = 'JobDefinition'


class JobDefinition:

    def __init__(self, id, display_name, attribute_groups, attributes):
        self._id = id
        self._attribute_groups = attribute_groups
        self._display_name = display_name
        self._attributes = attributes

    def get_definition_id(self):
        return self._id

    def get_display_name(self):
        return self._display_name

    def get_attribute_groups(self):
        return self._attribute_groups

    def get_attributes(self):
        return self._attributes

    def get_attribute_with_key(self, key):
        for job_attribute in self.get_attributes():
            if job_attribute.get_attribute().get_key() == key:
                return job_attribute
        else:
            raise ValueError("Could not find attribute with key '" + key + "'")

    def get_attributes_in_group(self, attribute_group):
        attributes = []
        for attribute in self.get_attributes():
            if attribute.get_attribute_group() == attribute_group:
                attributes.append(attribute)
        return attributes
