__all__ = 'JobPreset'

from .job_preset_attribute import JobPresetAttribute


class JobPreset(object):

    def __init__(self, name, id, job_definition, job_preset_attributes, is_locked = False):
        self._name = name
        self._id = id
        self._job_definition = job_definition
        self._job_preset_attributes = job_preset_attributes
        self._is_locked = is_locked

    def get_name(self):
        return self._name

    def set_name(self, name):
        self._name = name

    def get_id(self):
        return self._id

    def get_job_definition(self):
        return self._job_definition

    def get_job_preset_attributes(self):
        return self._job_preset_attributes

    def get_job_preset_attribute_by_key(self, key):
        for job_preset_attribute in self.get_job_preset_attributes():
            if job_preset_attribute.get_key() == key:
                return job_preset_attribute

        raise ValueError(u"No JobPresetAttribute with the key: " + unicode(key))

    def get_job_preset_attribute_by_id(self, id):
        for job_preset_attribute in self.get_job_preset_attributes():
            if job_preset_attribute.get_id() == id:
                return job_preset_attribute

        raise ValueError(u"No JobPresetAttribute with the id: " + unicode(id))

    def get_job_preset_attributes_in_group(self, attribute_group):
        job_preset_attributes = []
        for job_preset_attribute in self.get_job_preset_attributes():
            if job_preset_attribute.get_job_attribute().get_attribute_group() == attribute_group:
                job_preset_attributes.append(job_preset_attribute)
        return job_preset_attributes

    def is_locked(self):
        return self._is_locked

    def set_locked_state(self, is_locked):
        self._is_locked = is_locked

    def toggle_locked_state(self):
        self.set_locked_state(not self._is_locked)
