__all__ = 'LocalProject'

from abc import abstractmethod

from .project import Project


class LocalProject(Project):

    def __init__(self,
                 name,
                 root_dir,
                 files,
                 attributes):

        Project.__init__(self,
                         name,
                         root_dir,
                         files,
                         attributes)

    @abstractmethod
    def exists(self):
        raise NotImplementedError

    @abstractmethod
    def delete(self):
        raise NotImplementedError

    def get_size(self):
        project_size = 0
        for file in self.get_files():
            project_size += file.stat().st_size
        return project_size
