__all__ = 'PackedProject'

from gm_meta_plugin.local_project import LocalProject
from gm_meta_plugin.utils import remove_directory


class PackedProject(LocalProject):

    def __init__(self,
                 name,
                 root_dir,
                 files,
                 attributes):

        LocalProject.__init__(self,
                              name,
                              root_dir,
                              files,
                              attributes)

    def get_relative_file_path(self, file):
        root_dir = self.get_root_dir()

        if not file.is_absolute():
            raise ValueError("file \"" + unicode(file) + "\" must be absolute")

        if file.anchor != root_dir.anchor:
            raise ValueError("file \"" + unicode(file) + "\" must be on same drive as project directory (\"" +
                             unicode(root_dir.anchor) + "\")")

        return file.relative_to(root_dir)

    def get_relative_files(self):
        relative_files = map(self.get_relative_file_path, self.get_files())
        return set(relative_files)

    def exists(self):
        if self.get_root_dir().is_dir():
            return True

    def delete(self):
        if self.exists():
            remove_directory(self.get_root_dir())
