__all__ = 'WatchFile'


class WatchFile:

    def __init__(self, remote_watch_pattern, local_download_path):
        self._remote_watch_pattern = remote_watch_pattern
        self._local_download_path = local_download_path

    def get_remote_watch_pattern(self):
        return self._remote_watch_pattern

    def get_local_download_path(self):
        return self._local_download_path

    @staticmethod
    def parse_watch_files(watch_files_str):

        if not watch_files_str:
            return []

        components = watch_files_str.split(',')

        if len(components) % 2 != 0:
            error_message = "Could not parse watch files:\n{0}".format(str(watch_files_str))
            raise ValueError(unicode(error_message), "utf8")

        watch_files = []

        component_iterator = iter(components)
        for component in component_iterator:
            watch_files.append(WatchFile(component, next(component_iterator)))

        return watch_files

