__all__ = "AvailableCreditsPopup"

from PySide2 import QtCore
from PySide2 import QtWidgets

from gm_qt_plugin import qt_constants
from gm_qt_plugin.qt_plugin_accessor import QtPluginAccessor


class AvailableCreditsPopup(QtWidgets.QDialog, QtPluginAccessor):
    """
    A simple popup that displays the user's available credit balance.
    """

    def __init__(self, plugin, credits=0, parent=None):
        QtWidgets.QDialog.__init__(self, parent=parent)
        QtPluginAccessor.__init__(self, plugin)
        self._credits = credits

        self.setProperty(qt_constants.STYLE_PROPS.POPUP, True)  # used for styling
        self.setWindowFlags(QtCore.Qt.Popup)
        plugin.get_user_interface().set_style_sheet(self)

        self.layout = QtWidgets.QVBoxLayout(self)
        self.label = QtWidgets.QLabel(u"Available Credits:")
        self.available_credits_label = QtWidgets.QLabel(unicode(self.get_credits()))
        self.layout.addWidget(self.label)
        self.layout.addWidget(self.available_credits_label)

    def get_credits(self):
        return self._credits

    def set_credits(self, credits):
        self._credits = credits
        self.available_credits_label.setText(unicode(credits))
