from PySide2 import QtWidgets


class RightAlignedQMenu(QtWidgets.QMenu):

    def __init__(self, label, parent):
        QtWidgets.QMenu.__init__(self, label, parent=parent)
        self.setMinimumWidth(parent.minimumWidth())

    def showEvent(self, event):
        # Align the QMenu to the right of its parent
        p = self.pos()
        geo = self.parent().geometry()
        self.move(p.x() + geo.width() - self.geometry().width(), p.y())
